import java.util.*;

/**
 * Klasse zum speichern aller Artikel
 * der Stammdaten. Die Klasse ist ein Child der
 * LinkedList.
 *
 * @author Bernhard Fiser 0109815
 * @version 1.0
 */

public class ArtikelListe extends LinkedList
{
	/** Constructor, LinkedListe anlegen */
	public		ArtikelListe()
	{
		super();
	}

	/** Methode um bestimmten Artikel aus Liste auszuwhlen
	 * anhand der Artikelnummer.
	 * @param int nummer: Artikelnummer
	 * @return Artikel
	 */
	public Artikel	getArtikel(int nummer)
	{
		ListIterator	li;
		Artikel		a;

		/* ListIterator initialisieren */
		li = this.listIterator(0);
		a = null;
		/* Elemente der Liste einzeln durchgehen */
		while (li.hasNext())
		{
			a = (Artikel) li.next();
			/* Falls Artikel gefunden, Schleife abrechen */
			if (a.nummer == nummer)
				break;
		}
		/* Gefundenen Artikel zurckgeben (oder null, falls nicht) */
		return(a);
	}

	/** Methode um zu prfen, ob spezieller Artikel in der Liste vorhanden ist */
	public boolean	hasArtikel(int nummer)
	{
		ListIterator	li;
		Artikel		a;

		/* ListIterator initialisieren */
		li = this.listIterator(0);
		/* Alle Elemente einzeln durchgehen */
		while (li.hasNext())
		{
			a = (Artikel) li.next();
			/* Falls Element gefunden, true zurckgeben */
			if (a.nummer == nummer)
				return(true);
		}
		/* falls nicht gefunden, dann false zurckgeben */
		return(false);
	}
}