import java.util.*;

/**
 * Programm zur Rechungserstellung
 *
 * @author Bernhard Fiser 0109815
 * @version 1.0
 */

public class Rechnungserstellung
{
	static ArtikelListe	al;
	static Artikel		a;
	static ReadFile		fa;
	static ReadFile		fr;
	static int		lineno;
	static String		line;
	static RechnungsElement	re;
	static LinkedList	li;
	static ListIterator	lit;
	static double		total;
	static double		sp;
	static double		gtotal;

	/* Hauptprogramm */
	public static void main(String argv[])
	{
		/* Prfen ob gengen Parameter bergeben wurden */
		if (argv.length < 2)
		{
			System.err.println("*** usage: java Rechnungserstellung <artikelliste> <rechnung>");
			return;
		}

		/* Neue Artikelliste anlegen und Artikelfile ffnen */
		al = new ArtikelListe();
		fa = new ReadFile(".", argv[0]);
		lineno = 0;
		/* Zeilen einzeln einlesen */
		while ((line = fa.readLine()) != null)
		{
			lineno++;
			/* neuen Artikel anlegen */
			a = new Artikel();
			/* Eingelesene Zeile parsen und gegebenenfalls Fehler ausgeben */
			if (!a.parseArtikel(line))
			{
				System.err.println("*** " + argv[0] + ": syntax error in line " + lineno);
				return;
			}
			/* Falls alles ok, dann zur Artikelliste hinzufgen */
			al.add(a);
		}
		/* Artikelfile schlieen */
		fa.close();

		/* Rechnungsfile ffnen und LinkedList anlegen fr einzelne Rechnungselemente */
		fr = new ReadFile(".", argv[1]);
		li = new LinkedList();
		lineno = 0;
		/* Rechnungszeilen einzeln einlesen */
		while ((line = fr.readLine()) != null)
		{
			lineno++;
			/* Rechnungselement erstellen, und eingelesene Zeile parsen.
			 * Falls Fehler beim parsen, Fehler ausgeben und Programm beenden */
			re = new RechnungsElement();
			if (!re.parseRechnungsElement(line))
			{
				System.err.println("*** " + argv[1] + ": syntax error in line " + lineno);
				return;
			}
			/* Prfen ob Artikel in Artikelstammdaten existiert.
			 * Falls nicht, Fehler ausgeben und Programm beenden */
			if (!al.hasArtikel(re.nummer))
			{
				System.err.println("*** " + argv[1] + ": artikel " + re.nummer + " not found");
				return;
			}
			/* Wenn alles OK, dann Rechnungszeile zu Liste hinzufgen */
			li.add(re);
		}
		/* Rechungsfile schlieen */
		fr.close();
		/* Falls mehr als 10 Zeilen in Rechungsfile, Fehler ausgeben und
		 * Programm beenden */
		if (lineno > 10)
		{
			System.err.println("*** " + argv[1] + ": too much entries (> 10)");
			return;
		}

		/* Variablen fr Rechungsausgabe initialisieren
		 * gtotal: Rechnunsgesamtsumme */
		gtotal = 0;
		/* Listiterator */
		lit = li.listIterator(0);
		/* Artikel aus Stammdaten */
		a = new Artikel();
		/* Rechungselement */
		re = new RechnungsElement();
		/* Rechungskopfzeile ausgeben */
		System.out.println("ARTNR\tBEZ.\tPREIS/STK\tMENGE\tPREIS");
		/* Elemente der Liste einzeln durchgehen */
		while (lit.hasNext())
		{
			re = (RechnungsElement) lit.next();
			/* Artikel in Stammdaten suchen */
			a = al.getArtikel(re.nummer);
			/* Preis berechnen */
			total = re.menge * a.preis / 1000;
			sp = a.preis / 1000;
			/* Gesamtpreis erhhen */
			gtotal += total;
			/* Rechunungszeile ausgeben */
			System.out.println(a.nummer + "\t" + a.bezeichnung + "\t" + sp + "\t" + re.menge + "\t" + total);
		}
		/* Am Ende Gesamtsumme ausgeben */
		System.out.println("GESAMTSUMME: " + gtotal);
	}
}
